SystemOrganization addCategory: #MultiplayerDungeonGame!

SimpleBorder subclass: #PartialBorder
	instanceVariableNames: 'hasTop hasRight hasBottom hasLeft'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!PartialBorder class methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:22'!
width: width hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4
	^self new
		width: width;
		hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4.! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 03:08'!
frameRectangle: aRectangle on: aCanvas

	hasTop ifTrue: [aCanvas 
		line: aRectangle topLeft + (self width / 2) ceiling
		to: aRectangle topRight + (self width / 2) ceiling
		width: self width 
		color: self color].
	hasRight ifTrue: [aCanvas 
		line: aRectangle topRight - (self width / 2) ceiling
		to: aRectangle bottomRight - (self width / 2) ceiling
		width: self width 
		color: self color].
	hasBottom ifTrue: [aCanvas 
		line: aRectangle bottomRight - (self width / 2) ceiling
		to: aRectangle bottomLeft - (self width / 2) ceiling
		width: self width 
		color: self color].
	hasLeft ifTrue: [aCanvas 
		line: aRectangle bottomLeft + (self width / 2) ceiling
		to: aRectangle topLeft + (self width / 2) ceiling
		width: self width 
		color: self color].! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:12'!
hasTop: aBool1 hasRight: aBool2 hasBottom: aBool3 hasLeft: aBool4
	hasTop := aBool1.
	hasRight := aBool2.
	hasBottom := aBool3.
	hasLeft := aBool4.! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 02:49'!
initialize
	super initialize.
	self width: 7 .
	self color: Color black .
	self hasTop: true hasRight: true hasBottom: true hasLeft: true! !

!PartialBorder methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 01:26'!
style
	^#partial! !

Morph subclass: #Game
	instanceVariableNames: 'connectionSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!Game methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 04:21'!
handleCommand: receivedData withBoard: aBoard andPlayer: aPlayer 
	(receivedData = '28') ifTrue: [aBoard moveGameObjectLeft: aPlayer].
	(receivedData = '31') ifTrue: [aBoard moveGameObjectDown: aPlayer].
	(receivedData = '29') ifTrue: [aBoard moveGameObjectRight: aPlayer].
	(receivedData = '30') ifTrue: [aBoard moveGameObjectUp: aPlayer].! !

Game subclass: #GameClient
	instanceVariableNames: 'windowPosition isRunning isRunningLock gb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameClient methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:01'!
debugPrint: aString
	Transcript show: self asString, ':  ' , aString , '(' , Time now asMilliSeconds asString , ')' , Character cr asString! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:45'!
handleKeystroke: anEvent 
	| keyValue | 
 	keyValue := anEvent keyValue.
	self handleCommand: (keyValue asString) withBoard:  gb andPlayer: (gb player).
	isRunning ifTrue: [ connectionSocket sendData: keyValue asString ].! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/11/2014 05:12'!
handlesMouseOver: anEvent 
   ^ true! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:29'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	windowPosition := 50@50.
	gb := GameBoard new.
	! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 17:46'!
interactUsing: interactionSocket
	| receivedData window isSynced |
		
	[ 

	window := StandardWindow new.
	window open.
	self color: Color transparent.
	isSynced := false.
	
	receivedData := ''.
	[ 
	[interactionSocket isConnected ] whileTrue:  [  
		receivedData := ByteString new.
		
		(isSynced) ifFalse: [ self syncWithWindow:  window onSocket:  interactionSocket.
			isSynced := true
		 ].
		
		receivedData := interactionSocket receiveData.
		(receivedData size = 0) ifFalse: [ Transcript show: (gb hash) asString, Character cr asString ].
		
		(window isInWorld) ifFalse: [ ConnectionTimedOut signal ]
		
	]
	] on: ConnectionTimedOut
		do: [].
	]
	ensure: [
	interactionSocket closeAndDestroy.
	self delete. ] ! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 08:39'!
isRunning
	^ isRunningLock critical: [ isRunning ]! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 08:39'!
isRunning: aBoolean
	isRunningLock critical: [ isRunning := aBoolean ]! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 08:44'!
joinIP: anAddress.
	isRunningLock critical: [
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket connectTo: anAddress port: 9999.
	[self interactUsing: connectionSocket] fork! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 09:40'!
mouseEnter: anEvent 
    anEvent hand newKeyboardFocus: self! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/11/2014 05:16'!
mouseLeave: anEvent 
	anEvent hand newKeyboardFocus: nil! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 08:39'!
stop
	self isRunning: false! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:08'!
syncGame: gb withWindow: aWindow onSocket: aSocket
	| receivedData |
	receivedData := aSocket receiveData.
	[receivedData endsWith: 'complete' ] whileFalse: [	
		receivedData := receivedData , aSocket receiveData.
	].
	
	(receivedData size = 0) ifFalse:
	[
		receivedData readStream upToAll: 'complete'.
		gb := (FLMaterializer materializeFromByteArray:  receivedData asByteArray).
		(gb class = GameBoard) ifFalse: [self error: 'Non-GameBoard data received!!'].

		windowPosition := aWindow position.
		aWindow addMorph: gb.
		aWindow position: windowPosition.
		aWindow height: gb height + 30.
		aWindow width: gb width + 10.
		self position: (aWindow layoutBounds topLeft).
		self height: (aWindow layoutBounds bottom - aWindow layoutBounds top).
		self width: (aWindow layoutBounds right - aWindow layoutBounds left).
		aWindow addMorph: self.
	]
	! !

!GameClient methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 17:01'!
syncWithWindow: aWindow onSocket: aSocket
	| receivedData |
	receivedData := aSocket receiveData.
	[receivedData endsWith: 'complete' ] whileFalse: [	
		receivedData := receivedData , aSocket receiveData.
	].
	
	(receivedData size = 0) ifFalse:
	[
		receivedData readStream upToAll: 'complete'.
		gb := (FLMaterializer materializeFromByteArray:  receivedData asByteArray).
		(gb class = GameBoard) ifFalse: [self error: 'Non-GameBoard data received!!'].

		windowPosition := aWindow position.
		aWindow addMorph: gb.
		aWindow position: windowPosition.
		aWindow height: gb height + 30.
		aWindow width: gb width + 10.
		self position: (aWindow layoutBounds topLeft).
		self height: (aWindow layoutBounds bottom - aWindow layoutBounds top).
		self width: (aWindow layoutBounds right - aWindow layoutBounds left).
		aWindow addMorph: self.
	]
	! !

Game subclass: #GameServer
	instanceVariableNames: 'isRunning isRunningLock numConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameServer commentStamp: '<historical>' prior: 0!
A GameServer is opens a socket for connections and carries out the game logic. It keeps track of all connections, and their current game state.

Instance Variables
	connectionSocket:		<Object>
	isRunning:		<Object>
	isRunningLock:		<Object>
	numConnections:		<Object>

connectionSocket
	- xxxxx

isRunning
	- xxxxx

isRunningLock
	- xxxxx

numConnections
	- xxxxx
!

!GameServer methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:01'!
debugPrint: aString
	Transcript show: self asString, ':  ' , aString , '(' , Time now asMilliSeconds asString , ')' , Character cr asString! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	numConnections := 0
	! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:56'!
interactOnConnection
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 17:21'!
interactUsing: interactionSocket
	| player receivedData gb |
		
	[ 
		numConnections := numConnections + 1.
		player := GameObject new.
		gb := self setupGameBoard: player.
		gb openInWindow.
		
		self sendSerializedBoard: gb onSocket: interactionSocket.
		receivedData := ''.
		
		[interactionSocket isConnected ] whileTrue:  
		[
			[
				receivedData := interactionSocket receiveData .
				self handleCommand: receivedData withBoard: gb andPlayer: player.
				Transcript show: (gb hash asString) , Character cr asString.
				interactionSocket sendData: (gb hash) asString.
			] 
			on: ConnectionTimedOut
			do: [].
		]. 
	] ensure: [
	interactionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:52'!
isRunning
	^ isRunningLock critical: [ isRunning ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:53'!
isRunning: aBoolean
	isRunningLock critical: [ isRunning := aBoolean ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:16'!
numConnections
	^numConnections ! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/9/2014 13:14'!
numConnections: aNum
	numConnections := aNum! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 15:28'!
sendSerializedBoard: aBoard onSocket: aSocket
	|serializedBoard|
	
	serializedBoard := (FLSerializer serializeToByteArray: aBoard).
	serializedBoard := ByteString fromByteArray: serializedBoard.
	aSocket sendData: serializedBoard , 'complete'.! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:58'!
serve
	[ [ self isRunning ]
	whileTrue: [ self interactOnConnection ] ]
	ensure: [ connectionSocket closeAndDestroy ]! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:41'!
setupGameBoard: aPlayer
	|gb|
	gb := (GameBoard boardSize: 10 windowSize: 400).
	gb player: aPlayer.
	^gb at: 6 at: 2 addGameObject: (aPlayer)! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:57'!
start
	isRunningLock critical: [
	self isRunning ifTrue: [ ^ self ].
	self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: 9999 backlogSize: 10.
	[ self serve ] fork! !

!GameServer methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/8/2014 22:55'!
stop
	self isRunning: false! !

Morph subclass: #GameBoard
	instanceVariableNames: 'boardSize windowSize board lineWidth player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBoard class methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 03:54'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt
	^self new boardSize: aBoardSizeInt windowSize: aWindowSizeInt.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:21'!
at: anX at: aY addGameObject: aGameObject
	(board at: anX at: aY) setOccupant: aGameObject.
	aGameObject x: anX; y: aY.
	aGameObject position: (self positionOfX: anX Y: aY).
	self addMorph: aGameObject.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:16'!
boardSize: aBoardSizeInt windowSize: aWindowSizeInt

	self initialize.

	boardSize := aBoardSizeInt.
	windowSize := aWindowSizeInt.
	lineWidth := 2.
	board := Matrix new: aBoardSizeInt.
	
	self buildGrid.
	! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:23'!
buildGrid

	|spacing newBox|
	spacing := windowSize/boardSize.

	1 to: boardSize do:
	[ 
		:i |
		1 to: boardSize do:
		[ 
			:j |
			newBox := GameBox new.
			newBox width: spacing.
			newBox height: spacing.
			newBox borderStyle: (PartialBorder width: lineWidth hasTop: true hasRight: true hasBottom: true hasLeft: true).
			newBox position: ((i-1)*spacing)@((j-1)*spacing).
			board at: i at: j put: newBox.
			newBox x: i.
			newBox y: j.
			self addMorph: newBox.
		]
	 ]! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:26'!
fromX: fromX fromY: fromY toX: toX toY: toY
	|mover|
	mover := (board at: fromX at: fromY) occupant.
	mover x: toX; y: toY.
	mover position: (self positionOfX: toX Y: toY).
	(board at: toX at: toY) setOccupant: mover.
	(board at: fromX at: fromY) setOccupant: nil.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:56'!
hash
	^board hash ! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:53'!
moveGameObjectDown:  aGameObject
	aGameObject moveDownOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:44'!
moveGameObjectLeft:  aGameObject
	aGameObject moveLeftOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:45'!
moveGameObjectRight:  aGameObject
	aGameObject moveRightOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 06:45'!
moveGameObjectUp:  aGameObject
	aGameObject moveUpOnBoard: self.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:44'!
player
	^player! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'WestonPanther 7/14/2014 16:39'!
player: aPlayer
	player := aPlayer.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:37'!
positionOfX: anX Y: aY
	^(board at: anX at: aY) position.! !

Morph subclass: #GameObject
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameObject commentStamp: '<historical>' prior: 0!
A GameObject represents an entity that can occupy a space in the dungeon.

Instance Variables
	x:		<Object>
	y:		<Object>

x
	- xxxxx

y
	- xxxxx
!

GameObject subclass: #Denizen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameObject methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:39'!
hash
	^(self class hash * 10000) + (x hash * 100 ) + (y hash * 1)! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 04:01'!
initialize
	super initialize.
	self x: 1.
	self y: 1.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveDownOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y + 1.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveLeftOnBoard: aBoard
	self moveOnBoard: aBoard toX: x - 1 toY: y.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:51'!
moveOnBoard: aBoard toX: toX toY: toY
	aBoard fromX: x fromY: y toX: toX toY: toY.
	x := toX.
	y := toY.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:17'!
moveRight
	! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:48'!
moveRightOnBoard: aBoard
	self moveOnBoard: aBoard toX: x + 1 toY: y.
	! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:50'!
moveUpOnBoard: aBoard
	self moveOnBoard: aBoard toX: x toY: y - 1.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:34'!
x: anX
	x := anX.! !

!GameObject methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:34'!
y: aY
	y := aY.! !

BorderedMorph subclass: #GameBox
	instanceVariableNames: 'x y occupant northWall eastWall southWall westWall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiplayerDungeonGame'!

!GameBox methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:51'!
binaryWallRepresentation
	|representation|
	representation := 0.
	northWall ifTrue: [ representation := representation + 1000 ].
	eastWall ifTrue: [ representation := representation + 100 ].
	southWall ifTrue: [ representation := representation + 10 ].
	westWall ifTrue: [ representation := representation + 1 ].
	^Integer readFrom: representation asString base: 2.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HenrySolberg 7/15/2014 03:52'!
hash
	^occupant hash * 100 + self binaryWallRepresentation.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
initialize
	super initialize.
	x := 0.
	y := 0.
	northWall := true.
	eastWall := true.
	southWall := true.
	westWall := true.
	occupant := nil.
	color := Color gray.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
occupant
	^occupant! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 05:23'!
setOccupant: aGameObject.
	occupant := aGameObject.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:33'!
x: anX
	x := anX.! !

!GameBox methodsFor: 'as yet unclassified' stamp: 'HEnrySolberg 7/10/2014 04:24'!
y: aY
	y := aY.! !
